/// fisica_collision_handleCirclePolygon(Circle Inst, Polygon Inst)

var a = argument0;
var b = argument1;

contactCount = 0;

var center = mat2_multi(mat2_transpose(b.u), Vector2_subVector2(a.position, b.position));
var separation = -global.MAXREAL;
var faceNormal = 0;

for (var l = 0; l < b.vertexCount; ++l){
    
    var Vector2_normals  = Vector2_getArray(b.normals[l]);
    var Vector2_vertices = Vector2_getArray(b.vertices[l]);
    var s = Vector2_dot(Vector2_normals, Vector2_subVector2(center, Vector2_vertices));
    
    
    if (s > a.radius){
        exit;
    }
    
    if (s > separation){
        separation = s;
        faceNormal = l;
    } 
}

Vector2_normals = Vector2_getArray(b.normals[faceNormal]);
var v1 = Vector2_getArray(b.vertices[faceNormal]);
var i2;
if (faceNormal + 1 < b.vertexCount){
    i2 = faceNormal + 1;
}else{
    i2 = 0;
}
var v2 = Vector2_getArray(b.vertices[i2]);




if (separation < global.EPSILON){
    contactCount = 1;
    normal = Vector2_neg(mat2_mul(b.u, Vector2_normals[0], Vector2_normals[1])); /////    
    contacts[0] = Vector2_setArray(Vector2_addVector2(Vector2_multi(normal, a.radius), a.position));
    penetration = a.radius;
    exit;
}

var dot1 = Vector2_dot(Vector2_subVector2(center, v1), Vector2_subVector2(v2, v1));
var dot2 = Vector2_dot(Vector2_subVector2(center, v2), Vector2_subVector2(v1, v2));
penetration = a.radius - separation;

if (dot1 <= 0.0){
    if (Vector2_distanceSq(center, v1) > a.radius * a.radius){
        exit;
    }
    
    contactCount = 1;
    var n = Vector2_subVector2(v1, center);
    n = mat2_multi(b.u, n);
    n = Vector2_normalize(n);
    normal = n;
    
    v1 = Vector2_addVector2(mat2_multi(b.u, v1), b.position);
    contacts[0] = Vector2_setArray(v1);    
}else if (dot2 <= 0.0){
    if (Vector2_distanceSq(center, v2) > a.radius * a.radius){
        exit;
    }
    
    contactCount = 1;
    var n = Vector2_subVector2(v2, center);
    v2 = Vector2_addVector2(mat2_multi(b.u, v2), b.position);
    contacts[0] = Vector2_setArray(v2); 
    
    n = mat2_multi(b.u, n);
    n = Vector2_normalize(n);
    normal = n;       
}else{
    var n = Vector2_normals;
    
    if (Vector2_dot(Vector2_subVector2(center, v1), n) > a.radius){
        exit;
    }
    
    contactCount = 1;
    n = mat2_multi(b.u, n);
    normal = Vector2_neg(n);
    contacts[0] = Vector2_setArray(Vector2_addsVector2(a.position, normal, a.radius)); 
}