/// fisica_collision_handlePolygonPolygon(Polygon Inst A, Polygon Inst B)

var a = argument0;
var b = argument1;
contactCount = 0;

var result = fisica_collision_handlePolygonPolygon_findAxisLeastPenetration(a, b);
var faceA;
faceA[0] = result[0];
var penetrationA;
penetrationA = result[1];

if (penetrationA >= 0.0){
    exit;
}

result = fisica_collision_handlePolygonPolygon_findAxisLeastPenetration(b, a);
var faceB;
faceB[0] = result[0];
var penetrationB;
penetrationB = result[1];

if (penetrationB >= 0.0){
    exit;
}


var referenceIndex;
var flip;

var RefPoly;
var IncPoly;

if (fisica_math_gt(penetrationA, penetrationB)){
    RefPoly = a;
    IncPoly = b;
    referenceIndex = faceA[0];
    flip = false;
}else{
    RefPoly = b;
    IncPoly = a;
    referenceIndex = faceB[0];
    flip = true;
}

var incidentFace;
incidentFace = fisica_collision_handlePolygonPolygon_findIncidentFace(RefPoly, IncPoly, referenceIndex);

var v1 = Vector2_getArray(RefPoly.vertices[referenceIndex]);
if (referenceIndex + 1 == RefPoly.vertexCount){
    referenceIndex = 0;
}else{
    referenceIndex++;
}
var v2 = Vector2_getArray(RefPoly.vertices[referenceIndex]);

v1 = Vector2_addVector2(mat2_multi(RefPoly.u, v1), RefPoly.position);
v2 = Vector2_addVector2(mat2_multi(RefPoly.u, v2), RefPoly.position);





var sidePlaneNormal = Vector2_subVector2(v2, v1);
sidePlaneNormal = Vector2_normalize(sidePlaneNormal);

refFaceNormal = Vector2(Vector2_getY(sidePlaneNormal), -Vector2_getX(sidePlaneNormal));


var refC = Vector2_dot(refFaceNormal, v1);
var negSide = -Vector2_dot(sidePlaneNormal, v1);
var posSide = Vector2_dot(sidePlaneNormal, v2);


var clip = fisica_collision_handlePolygonPolygon_clip(Vector2_neg(sidePlaneNormal), negSide, incidentFace);

incidentFace[0] = clip[0];
incidentFace[1] = clip[1];
if (clip[2] < 2){
    incidentFace[0] = Vector2_freeArray(incidentFace[0]);
    incidentFace[1] = Vector2_freeArray(incidentFace[1]);
    exit;
}

clip = fisica_collision_handlePolygonPolygon_clip(sidePlaneNormal, posSide, incidentFace);
incidentFace[0] = clip[0];
incidentFace[1] = clip[1];


if (clip[2] < 2){
    incidentFace[0] = Vector2_freeArray(incidentFace[0]);
    incidentFace[1] = Vector2_freeArray(incidentFace[1]);
    exit;
}

normal = refFaceNormal;
if (flip){
    normal = Vector2_neg(normal);
}

var cp = 0;
var Vector2_incidentFace0 = Vector2_getArray(incidentFace[0]);
var separation = Vector2_dot(refFaceNormal, Vector2_incidentFace0) - refC;


if (separation <= 0.0){
    contacts[cp] = Vector2_setArray(Vector2_incidentFace0)
    penetration = -separation;
    ++cp;
}else{
    penetration = 0;
}

var Vector2_incidentFace1 = Vector2_getArray(incidentFace[1]);
separation = Vector2_dot(refFaceNormal, Vector2_incidentFace1) - refC;

if (separation <= 0.0){
    contacts[cp] = Vector2_setArray(Vector2_incidentFace1)
    penetration += -separation;
    ++cp;
    penetration /= cp;
}

contactCount = cp;
incidentFace[0] = Vector2_freeArray(incidentFace[0]);
incidentFace[1] = Vector2_freeArray(incidentFace[1]);
