/// fisica_polygon_computeMass(density)

var density = argument0;
var c = Vector2(0.0, 0.0);
var area = 0.0;
var I = 0.0;
var k_inv3 = 1.0/3.0;


for (var l = 0; l < vertexCount; ++l){
    
    var p1 = (Vector2_getArray(vertices[l]));
    var p2 = (Vector2_getArray(vertices[(l + 1) % vertexCount]));
    
    var D = Vector2_cross(p1, p2);
    var triangleArea = 0.5 * D;
    area += triangleArea;
    
    var weight = triangleArea * k_inv3;
    c = Vector2_addsVector2(c, p1, weight);
    c = Vector2_addsVector2(c, p2, weight);
    
    var intx2 = p1[0] * p1[0] + p2[0] * p1[0] + p2[0] * p2[0];
    var inty2 = p1[1] * p1[1] + p2[1] * p1[1] + p2[1] * p2[1];
    I += (0.25 * k_inv3 *D) * (intx2 + inty2);
}

c = Vector2_multi(c, 1.0/area);

for (var l = 0; l < vertexCount; l++){
    var ver = Vector2_getArray(vertices[l]);
    vertices[l] = Vector2_sameArray(Vector2_subVector2(ver, c), vertices[l]);
}

mass = density * area;

if (mass != 0.0){
    invMass = 1.0 / mass;
}else{
    invMass = 0.0;
}

inertia = I * density;

if (inertia != 0.0){
    invInertia = 1.0 / inertia;
}else{
    invInertia = 0.0;
}