/// fisica_polygon_set(Vector2 Array)

var arrayVector = argument0;
var rightMost = 0;
var highestXCoord = Vector2_getX(Vector2_getArray(arrayVector[0])); 

for(var l = 1; l < array_length_1d(arrayVector); l++){
    var Vector2_Array = (Vector2_getArray(arrayVector[l])); 
    var _x = Vector2_getX(Vector2_Array);
    var _y = Vector2_getY(Vector2_Array);
    
    if (_x > highestXCoord){
        highestXCoord = _x;
        rightMost = l;
    }else if (_x == highestXCoord){
        if (_y < Vector2_getY(Vector2_getArray(arrayVector[rightMost]))){
            rightMost = l;
        }
    }
}

var hull, k;
k = MAX_POLY_VERTEX_COUNT;
while(k >= 0){
    hull[k] = 0;
    k--;
}

var outCount = 0;
var indexHull = rightMost;

while(true){
    hull[outCount] = indexHull;
    var nextHullIndex = 0;
    for (var l = 1; l < array_length_1d(arrayVector); ++l){
        if (nextHullIndex == indexHull){
            nextHullIndex = l;
            continue;
        }
        var Vector2_nextHullIndex = (Vector2_getArray(arrayVector[nextHullIndex])); 
        var Vector2_hullOutCount  = (Vector2_getArray(arrayVector[hull[outCount]]));
        var Vector2_Array         = Vector2_getArray(arrayVector[l]); 
        var e1 = Vector2_subVector2(Vector2_nextHullIndex, Vector2_hullOutCount);
        var e2 = Vector2_subVector2(Vector2_Array, Vector2_hullOutCount);
        
        var c = Vector2_cross(e1, e2);
        if (c < 0.0){
            nextHullIndex = l;
        }
        
        if (c == 0.0 && Vector2_lengthSquare(e2) > Vector2_lengthSquare(e1)){
            nextHullIndex = l;
        }
    }
    ++outCount;
    indexHull = nextHullIndex;
    
    if (nextHullIndex == rightMost){
        vertexCount = outCount;
        break;
    }
}

for (var l = 0; l < vertexCount; ++l){
    vertices[l] = Vector2_setArray(Vector2_getArray(arrayVector[hull[l]]));
}

for (var l = 0; l < vertexCount; l++){
    var Vector2_vertices = Vector2_getArray(vertices[(l + 1) % vertexCount]); 
    var Vector2_vertices2 = Vector2_getArray(vertices[l]);
    var face = Vector2_subVector2(Vector2_vertices, Vector2_vertices2);
    
    normals[l] = Vector2_setArray(Vector2(Vector2_getY(face), -Vector2_getX(face)));
    normals[l] = Vector2_sameArray(Vector2_normalize(Vector2_getArray(normals[l])), normals[l]);
}





