// Generate new collision info

for (var i = 0; i < ds_list_size(global.contactss); i++){
    var getManifold = global.contactss[| i];
    manifold_loadData(getManifold);
    for (var j = 0; j < contactCount; j++){
        contacts[j] = Vector2_freeArray(contacts[j]);
    }
    
    getManifold = noone;
}
ds_list_clear(global.contactss);

for (var i = 0; i < ds_list_size(global.bodies); ++i){
    var aBody = global.bodies[| i];

    for (var j = i + 1; j < ds_list_size(global.bodies); ++j){
        var bBody = global.bodies[| j];
                
        if (aBody.invMass == 0 && bBody.invMass == 0){
            continue;
        }
        
        manifold_init(aBody, bBody);
        manifold_solve();
        
        if (contactCount > 0){
            manifold_saveData();
            var list = ds_list_create();
            ds_list_copy(list, manifoldList);
            ds_list_add(global.contactss, list);            
        }
    }
}


// Intergrate Forces
for (var i = 0; i < ds_list_size(global.bodies); i++){
    fisica_integrateForces(global.bodies[| i], global.DT, 1 /*global.deltaTime*/);
}

//Initialize Collision
var contactsCount = ds_list_size(global.contactss);
for (var i = 0; i < contactsCount; i++){
    var getManifold = global.contactss[| i];
    manifold_loadData(getManifold);
    manifold_start();
    manifold_saveData();
    var array = manifoldList;
    ds_list_replace(global.contactss, i, manifoldList);
}

//Solve collisions
//for (var j = 0; j < 10; j++){
    for (var i = 0; i < contactsCount; i++){
        var getManifold = global.contactss[| i];
        manifold_loadData(getManifold);
        manifold_applyImpulse();
        manifold_saveData();
        var array = manifoldList;
        ds_list_replace(global.contactss, i, manifoldList);
    }
//}

//Integrate velocities
for (var i = 0; i < ds_list_size(global.bodies); i++)
{
    fisica_integrateVelocity(global.bodies[| i], global.DT, 1 /*global.deltaTime*/); ////
}

//Correct positions
for (var i = 0; i < contactsCount; i++){
    var getManifold = global.contactss[| i];
    manifold_loadData(getManifold);
    manifold_positionalCorrection();
    manifold_saveData();
    var array = manifoldList;
    ds_list_replace(global.contactss, i, manifoldList);
}

for (var i = 0; i < ds_list_size(global.bodies); i++){
    var bBody = global.bodies[| i];
    //Transfer Position
    bBody.x = Vector2_getX(bBody.position);
    bBody.y = Vector2_getY(bBody.position);
}

//Clear all forces
for (var i = 0; i < ds_list_size(global.bodies); i++){
    var cBody = global.bodies[| i];
    cBody.force = Vector2(0,0);
    cBody.torque = 0;
}
