/// manifold_applyImpulse()

if (fisica_math_equal(A.invMass + B.invMass, 0)){
    manifold_infiniteMassCorrection();
    exit;
}

for (var l = 0; l < contactCount; l++){
    var Vector2_contacts = (Vector2_getArray(contacts[l]))
    var ra = Vector2_subVector2(Vector2_contacts, A.position);
    var rb = Vector2_subVector2(Vector2_contacts, B.position);
    
    var rv = Vector2_subVector2(Vector2_subVector2(Vector2_addVector2(B.velocity, Vector2_crossReal(B.angularVelocity, rb)), A.velocity), Vector2_crossReal(A.angularVelocity, ra));
    
    var contactVel = Vector2_dot(rv, normal);
    
    if (contactVel > 0){
        exit;
    }
    var raCrossN = Vector2_cross(ra, normal);
    var rbCrossN = Vector2_cross(rb, normal);
    var invMassSum = A.invMass + B.invMass + (raCrossN * raCrossN) * A.invInertia + (rbCrossN * rbCrossN) * B.invInertia;
    
    var j = -(1.0 + e) * contactVel;
    j /= invMassSum;
    j /= contactCount;
    
    var impulse = Vector2_multi(normal, j);
    with(A){    fisica_applyImpulse(-impulse[0], -impulse[1], ra[0], ra[1]);      }
    with(B){    fisica_applyImpulse( impulse[0],  impulse[1], rb[0], rb[1]);      }
    
    rv = Vector2_subVector2(Vector2_subVector2(Vector2_addVector2(B.velocity, Vector2_crossReal(B.angularVelocity, rb)), A.velocity), Vector2_crossReal(A.angularVelocity, ra)); 
    
    var t = rv;
    t = Vector2_addsVector2(t, normal, -Vector2_dot(rv, normal));
    t = Vector2_normalize(t);
    
    var jt = -Vector2_dot(rv, t);
    jt /= invMassSum;
    jt /= contactCount;
    
    if (fisica_math_equal(jt, 0)){
        exit;
    }
    
    var tangentImpulse;
    if (abs(jt) < j * sf){
        tangentImpulse = Vector2_multi(t, jt);
    }else{
        tangentImpulse = Vector2_multi(Vector2_multi(t, j), -df);
    }

    with(A) {   fisica_applyImpulse(-tangentImpulse[0], -tangentImpulse[1], ra[0], ra[1]);     };
    with(B) {   fisica_applyImpulse( tangentImpulse[0],  tangentImpulse[1], rb[0], rb[1]);     };
}




